package ajedrez.server.dominio;

import junit.framework.TestCase;

public class PeonNoBlancoNiNegro extends TestCase {

	
	public void testPeonMoverDobleColorMenorN(){
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		
		Peon po = (Peon)t.getTablero()[6][3];
		po.cColor = 'm';
		t.setTurno('m');
		dev = t.mover('m', 7, 4, 5, 4, "e7", "e5");
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonSimpleDobleColorMenorN(){
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		
		Peon po = (Peon)t.getTablero()[6][3];
		po.cColor = 'm';
		t.setTurno('m');
		dev = t.mover('m', 7, 4, 6, 4, "e7", "e6");
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonMoverDobleColorMayorN(){
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		
		Peon po = (Peon)t.getTablero()[6][3];
		po.cColor = 'o';
		t.setTurno('o');
		dev = t.mover('o', 7, 4, 5, 4, "e7", "e5");
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonSimpleDobleColorMayorN(){
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		
		Peon po = (Peon)t.getTablero()[6][3];
		po.cColor = 'o';
		t.setTurno('o');
		dev = t.mover('o', 7, 4, 6, 4, "e7", "e6");
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonMoverDobleColorMenor(){
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		
		Peon po = (Peon)t.getTablero()[1][3];
		po.cColor = 'a';
		t.setTurno('a');
		dev = t.mover('a', 2, 4, 4, 4, "e2", "e4");
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonMoverSimpleColorMenor(){
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		
		Peon po = (Peon)t.getTablero()[1][3];
		po.cColor = 'a';
		t.setTurno('a');
		dev = t.mover('a', 2, 4, 3, 4, "e2", "e3");
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonMoverDobleColorMayor(){
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		
		Peon po = (Peon)t.getTablero()[1][3];
		po.cColor = 'c';
		t.setTurno('c');
		dev = t.mover('c', 2, 4, 4, 4, "e2", "e4");
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonMoverSimpleColorMayor(){
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		
		Peon po = (Peon)t.getTablero()[1][3];
		po.cColor = 'c';
		t.setTurno('c');
		dev = t.mover('c', 2, 4, 3, 4, "e2", "e3");
		
		super.assertEquals(-5, dev);
	}
	
	
	public void testPeonComerAlPasoIzquierdaBlancaColorMenor() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 3, 5, 3, "f7", "f5");
		t.almacenarMovimiento("f7-f5");
		
		
		Peon po = (Peon)t.getTablero()[4][3];
		po.cColor = 'a';
		t.setTurno('a');
		dev = t.mover('a', 5, 4, 6, 3, "e5", "f6");
		
		super.assertEquals(-5, dev);
		
	}
	
	public void testPeonComerAlPasoDerechaBlancaColorMenor() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 5, 5, 5, "d7", "d5");
		t.almacenarMovimiento("d7-d5");
		
		Peon po = (Peon)t.getTablero()[4][3];
		po.cColor = 'a';
		t.setTurno('a');
		dev = t.mover('a', 5, 4, 6, 5, "e5", "d6");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerAlPasoIzquierdaBlancaColorMayor() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 3, 5, 3, "f7", "f5");
		t.almacenarMovimiento("f7-f5");
		
		
		Peon po = (Peon)t.getTablero()[4][3];
		po.cColor = 'c';
		t.setTurno('c');
		dev = t.mover('c', 5, 4, 6, 3, "e5", "f6");
		
		super.assertEquals(-5, dev);
		
	}
	
	public void testPeonComerAlPasoDerechaBlancaColorMayor() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 5, 5, 5, "d7", "d5");
		t.almacenarMovimiento("d7-d5");
		
		Peon po = (Peon)t.getTablero()[4][3];
		po.cColor = 'c';
		t.setTurno('c');
		dev = t.mover('c', 5, 4, 6, 5, "e5", "d6");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerAlPasoIzquierdaNegraColorMenor() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		
		t.mover('n', 7, 4, 5, 4, "e7", "e5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 4, 4, 4, "e5", "e4");
		t.mover('b', 2, 3, 4, 3, "f2", "f4");
		t.almacenarMovimiento("f2-f4");
		
		Peon po = (Peon)t.getTablero()[3][3];
		po.cColor = 'm';
		t.setTurno('m');
		
		dev = t.mover('m', 4, 4, 3, 3, "e4", "f3");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerAlPasoDerechaNegraColorMenor() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 3, 5, 3, "f7", "f5");
		t.mover('b', 2, 8, 3, 8, "a7", "a3");
		t.mover('n', 5, 3, 4, 3, "f5", "f4");
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.almacenarMovimiento("e2-e4");
		
		Peon po = (Peon)t.getTablero()[3][2];
		po.cColor = 'm';
		t.setTurno('m');
		dev = t.mover('m', 4, 3, 3, 4, "f4", "e3");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerAlPasoIzquierdaNegraColorMayor() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		
		t.mover('n', 7, 4, 5, 4, "e7", "e5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 4, 4, 4, "e5", "e4");
		t.mover('b', 2, 3, 4, 3, "f2", "f4");
		t.almacenarMovimiento("f2-f4");
		
		Peon po = (Peon)t.getTablero()[3][3];
		po.cColor = 'o';
		t.setTurno('o');
		
		dev = t.mover('o', 4, 4, 3, 3, "e4", "f3");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerAlPasoDerechaNegraColorMayor() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 3, 5, 3, "f7", "f5");
		t.mover('b', 2, 8, 3, 8, "a7", "a3");
		t.mover('n', 5, 3, 4, 3, "f5", "f4");
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.almacenarMovimiento("e2-e4");
		
		Peon po = (Peon)t.getTablero()[3][2];
		po.cColor = 'o';
		t.setTurno('o');
		dev = t.mover('o', 4, 3, 3, 4, "f4", "e3");
		
		
		super.assertEquals(-5, dev);
	}
	
	
	
	public void testPeonComerIBlancaColorMenor() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 3, 6, 3, "f7", "f6");
		t.almacenarMovimiento("f7-f6");
		
		
		Peon po = (Peon)t.getTablero()[4][3];
		po.cColor = 'a';
		t.setTurno('a');
		dev = t.mover('a', 5, 4, 6, 3, "e5", "f6");
		
		super.assertEquals(-5, dev);
		
	}
	

	
	public void testPeonComerDBlancaColorMenor() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 5, 6, 5, "d7", "d6");
		t.almacenarMovimiento("d7-d6");
		
		Peon po = (Peon)t.getTablero()[4][3];
		po.cColor = 'a';
		t.setTurno('a');
		dev = t.mover('a', 5, 4, 6, 5, "e5", "d6");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerIBlancaColorMayor() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 3, 6, 3, "f7", "f6");
		t.almacenarMovimiento("f7-f6");
		
		
		Peon po = (Peon)t.getTablero()[4][3];
		po.cColor = 'c';
		t.setTurno('c');
		dev = t.mover('c', 5, 4, 6, 3, "e5", "f6");
		
		super.assertEquals(-5, dev);
		
	}
	
	public void testPeonComerDBlancaColorMayor() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 5, 6, 5, "d7", "d6");
		t.almacenarMovimiento("d7-d6");
		
		Peon po = (Peon)t.getTablero()[4][3];
		po.cColor = 'c';
		t.setTurno('c');
		dev = t.mover('c', 5, 4, 6, 5, "e5", "d6");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerINegraColorMenor() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		
		t.mover('n', 7, 4, 5, 4, "e7", "e5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 4, 4, 4, "e5", "e4");
		t.mover('b', 2, 3, 3, 3, "f2", "f3");
		t.almacenarMovimiento("f2-f3");
		
		Peon po = (Peon)t.getTablero()[3][3];
		po.cColor = 'm';
		t.setTurno('m');
		
		dev = t.mover('m', 4, 4, 3, 3, "e4", "f3");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerDNegraColorMenor() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 3, 5, 3, "f7", "f5");
		t.mover('b', 2, 8, 3, 8, "a7", "a3");
		t.mover('n', 5, 3, 4, 3, "f5", "f4");
		t.mover('b', 2, 4, 3, 4, "e2", "e3");
		t.almacenarMovimiento("e2-e3");
		
		Peon po = (Peon)t.getTablero()[3][2];
		po.cColor = 'm';
		t.setTurno('m');
		dev = t.mover('m', 4, 3, 3, 4, "f4", "e3");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerINegraColorMayor() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		
		t.mover('n', 7, 4, 5, 4, "e7", "e5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 4, 4, 4, "e5", "e4");
		t.mover('b', 2, 3, 3, 3, "f2", "f3");
		t.almacenarMovimiento("f2-f3");
		
		Peon po = (Peon)t.getTablero()[3][3];
		po.cColor = 'o';
		t.setTurno('o');
		
		dev = t.mover('o', 4, 4, 3, 3, "e4", "f3");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerDNegraColorMayor() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 3, 5, 3, "f7", "f5");
		t.mover('b', 2, 8, 3, 8, "a7", "a3");
		t.mover('n', 5, 3, 4, 3, "f5", "f4");
		t.mover('b', 2, 4, 3, 4, "e2", "e3");
		t.almacenarMovimiento("e2-e3");
		
		Peon po = (Peon)t.getTablero()[3][2];
		po.cColor = 'o';
		t.setTurno('o');
		dev = t.mover('o', 4, 3, 3, 4, "f4", "e3");
		
		
		super.assertEquals(-5, dev);
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	public void testPeonComerAlPasoIzquierdaBlancaColorMenorLaotra() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 3, 5, 3, "f7", "f5");
		t.almacenarMovimiento("f7-f5");
		
		
		Peon po = (Peon)t.getTablero()[4][2];
		po.cColor = 'm';
		dev = t.mover('b', 5, 4, 6, 3, "e5", "f6");
		
		super.assertEquals(-5, dev);
		
	}
	
	public void testPeonComerAlPasoDerechaBlancaColorMenorLaotra() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 5, 5, 5, "d7", "d5");
		t.almacenarMovimiento("d7-d5");
		
		Peon po = (Peon)t.getTablero()[4][4];
		po.cColor = 'm';
		dev = t.mover('b', 5, 4, 6, 5, "e5", "d6");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerAlPasoIzquierdaBlancaColorMayorLaotra() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 3, 5, 3, "f7", "f5");
		t.almacenarMovimiento("f7-f5");
		
		
		Peon po = (Peon)t.getTablero()[4][2];
		po.cColor = 'o';
		dev = t.mover('b', 5, 4, 6, 3, "e5", "f6");
		
		super.assertEquals(-5, dev);
		
	}
	
	public void testPeonComerAlPasoDerechaBlancaColorMayorLaotra() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 5, 5, 5, "d7", "d5");
		t.almacenarMovimiento("d7-d5");
		
		Peon po = (Peon)t.getTablero()[4][4];
		po.cColor = 'o';
		dev = t.mover('b', 5, 4, 6, 5, "e5", "d6");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerAlPasoIzquierdaNegraColorMenorLaotra() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		
		t.mover('n', 7, 4, 5, 4, "e7", "e5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 4, 4, 4, "e5", "e4");
		t.mover('b', 2, 3, 4, 3, "f2", "f4");
		t.almacenarMovimiento("f2-f4");
		
		Peon po = (Peon)t.getTablero()[3][2];
		po.cColor = 'a';
		dev = t.mover('n', 4, 4, 3, 3, "e4", "f3");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerAlPasoDerechaNegraColorMenorLaotra() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 3, 5, 3, "f7", "f5");
		t.mover('b', 2, 8, 3, 8, "a7", "a3");
		t.mover('n', 5, 3, 4, 3, "f5", "f4");
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.almacenarMovimiento("e2-e4");
		
		Peon po = (Peon)t.getTablero()[3][3];
		po.cColor = 'a';
		dev = t.mover('n', 4, 3, 3, 4, "f4", "e3");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerAlPasoIzquierdaNegraColorMayorLaotra() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		
		t.mover('n', 7, 4, 5, 4, "e7", "e5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 4, 4, 4, "e5", "e4");
		t.mover('b', 2, 3, 4, 3, "f2", "f4");
		t.almacenarMovimiento("f2-f4");
		
		Peon po = (Peon)t.getTablero()[3][2];
		po.cColor = 'c';
		dev = t.mover('n', 4, 4, 3, 3, "e4", "f3");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerAlPasoDerechaNegraColorMayorLaotra() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 3, 5, 3, "f7", "f5");
		t.mover('b', 2, 8, 3, 8, "a7", "a3");
		t.mover('n', 5, 3, 4, 3, "f5", "f4");
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.almacenarMovimiento("e2-e4");
		
		Peon po = (Peon)t.getTablero()[3][3];
		po.cColor = 'c';
		dev = t.mover('n', 4, 3, 3, 4, "f4", "e3");
		
		
		super.assertEquals(-5, dev);
	}
	
	
	
	public void testPeonComerIBlancaColorMenorLaotra() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 3, 6, 3, "f7", "f6");
		t.almacenarMovimiento("f7-f6");
		
		
		Peon po = (Peon)t.getTablero()[5][2];
		po.cColor = 'm';
		dev = t.mover('b', 5, 4, 6, 3, "e5", "f6");
		
		super.assertEquals(-5, dev);
		
	}
	

	
	public void testPeonComerDBlancaColorMenorLaotra() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 5, 6, 5, "d7", "d6");
		t.almacenarMovimiento("d7-d6");
		
		Peon po = (Peon)t.getTablero()[5][4];
		po.cColor = 'm';
		dev = t.mover('b', 5, 4, 6, 5, "e5", "d6");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerIBlancaColorMayorLaotra() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 3, 6, 3, "f7", "f6");
		t.almacenarMovimiento("f7-f6");
		
		
		Peon po = (Peon)t.getTablero()[5][2];
		po.cColor = 'o';
		dev = t.mover('b', 5, 4, 6, 3, "e5", "f6");
		
		super.assertEquals(-5, dev);
		
	}
	
	public void testPeonComerDBlancaColorMayorLaotra() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		
		t.mover('b', 2, 4, 4, 4, "e2", "e4");
		t.mover('n', 7, 8, 6, 8, "a7", "a6");
		t.mover('b', 4, 4, 5, 4, "e4", "e5");
		t.mover('n', 7, 5, 6, 5, "d7", "d6");
		t.almacenarMovimiento("d7-d6");
		
		Peon po = (Peon)t.getTablero()[5][4];
		po.cColor = 'o';
		dev = t.mover('b', 5, 4, 6, 5, "e5", "d6");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerINegraColorMenorLaotra() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		
		t.mover('n', 7, 4, 5, 4, "e7", "e5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 4, 4, 4, "e5", "e4");
		t.mover('b', 2, 3, 3, 3, "f2", "f3");
		t.almacenarMovimiento("f2-f3");
		
		Peon po = (Peon)t.getTablero()[2][2];
		po.cColor = 'a';
		dev = t.mover('n', 4, 4, 3, 3, "e4", "f3");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerDNegraColorMenorLaotra() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 3, 5, 3, "f7", "f5");
		t.mover('b', 2, 8, 3, 8, "a7", "a3");
		t.mover('n', 5, 3, 4, 3, "f5", "f4");
		t.mover('b', 2, 4, 3, 4, "e2", "e3");
		t.almacenarMovimiento("e2-e3");
		
		Peon po = (Peon)t.getTablero()[2][3];
		po.cColor = 'a';
		dev = t.mover('n', 4, 3, 3, 4, "f4", "e3");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerINegraColorMayorLaotra() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		
		t.mover('n', 7, 4, 5, 4, "e7", "e5");
		t.mover('b', 2, 8, 3, 8, "a2", "a3");
		t.mover('n', 5, 4, 4, 4, "e5", "e4");
		t.mover('b', 2, 3, 3, 3, "f2", "f3");
		t.almacenarMovimiento("f2-f3");
		
		Peon po = (Peon)t.getTablero()[2][2];
		po.cColor = 'c';
		dev = t.mover('n', 4, 4, 3, 3, "e4", "f3");
		
		
		super.assertEquals(-5, dev);
	}
	
	public void testPeonComerDNegraColorMayorLaotra() {
		int dev;
		
		Tablero t = new Tablero(1, "Jugador1", "Jugador2");
		t.setTurno('n');
		t.mover('n', 7, 3, 5, 3, "f7", "f5");
		t.mover('b', 2, 8, 3, 8, "a7", "a3");
		t.mover('n', 5, 3, 4, 3, "f5", "f4");
		t.mover('b', 2, 4, 3, 4, "e2", "e3");
		t.almacenarMovimiento("e2-e3");
		
		Peon po = (Peon)t.getTablero()[2][3];
		po.cColor = 'c';
		dev = t.mover('n', 4, 3, 3, 4, "f4", "e3");
		
		
		super.assertEquals(-5, dev);
	}
}
