package ajedrez.server.dominio;

import junit.framework.TestCase;

public class TestMoverMal extends TestCase {

	Tablero t;
	protected void setUp(){
		t = new Tablero(1, "ja", "jb");
		Pieza[][] tablero = t.getTablero();
		for(int i = 0;i<tablero.length;i++){
			for(int j = 0;j<tablero[i].length;j++){
				tablero[i][j] = null;
			}
		}
		
		Pieza[] pb = t.getBlancas();
		for(int i = 0;i<pb.length;i++){
			pb[i] = null;
		}
		
		
		Pieza[] pn = t.getNegras();
		for(int i = 0;i<pn.length;i++){
			pn[i] = null;
		}
	}
	
	
	protected Peon addPeon(int fila, int colum, char color, int numero){
		Peon p = new Peon(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		
		if(color == 'b'){
			t.getBlancas()[numero] = p;
			
		}else{
			t.getNegras()[numero] = p;
		}
		return p;
	}
	
	protected Torre addTorre1(int fila, int colum, char color){
		Torre p = new Torre(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		if(color == 'b'){
			t.getBlancas()[t.fnTorre1] = p;
		}else{
			t.getNegras()[t.fnTorre1] = p;
		}
		return p;
	}
	protected Torre addTorre2(int fila, int colum, char color){
		Torre p = new Torre(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		if(color == 'b'){
			t.getBlancas()[t.fnTorre2] = p;
		}else{
			t.getNegras()[t.fnTorre2] = p;
		}
		return p;
	}
	
	protected Caballo addCaballo1(int fila, int colum, char color){
		Caballo p = new Caballo(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		if(color == 'b'){
			t.getBlancas()[t.fnCaballo1] = p;
		}else{
			t.getNegras()[t.fnCaballo1] = p;
		}
		return p;
	}
	protected Caballo addCaballo2(int fila, int colum, char color){
		Caballo p = new Caballo(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		if(color == 'b'){
			t.getBlancas()[t.fnCaballo2] = p;
		}else{
			t.getNegras()[t.fnCaballo2] = p;
		}
		return p;
	}
	
	protected Alfil addAlfil1(int fila, int colum, char color){
		Alfil p = new Alfil(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		if(color == 'b'){
			t.getBlancas()[t.fnAlfil1] = p;
		}else{
			t.getNegras()[t.fnAlfil1] = p;
		}
		return p;
	}
	protected Alfil addAlfil2(int fila, int colum, char color){
		Alfil p = new Alfil(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		if(color == 'b'){
			t.getBlancas()[t.fnAlfil2] = p;
		}else{
			t.getNegras()[t.fnAlfil2] = p;
		}
		return p;
	}
	
	protected Dama addDama(int fila, int colum, char color){
		Dama p = new Dama(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		if(color == 'b'){
			t.getBlancas()[t.fnDama] = p;
		}else{
			t.getNegras()[t.fnDama] = p;
		}
		return p;
	}
	
	protected Rey addRey(int fila, int colum, char color){
		Rey p = new Rey(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		if(color == 'b'){
			t.getBlancas()[t.fnRey] = p;
		}else{
			t.getNegras()[t.fnRey] = p;
		}
		return p;
	}
	
	
	public void testMoverNegrasSinDeber(){
		t = new Tablero(1, "a", "b");
		int r = t.mover('n', 7, 2, 6, 2, "", "");
		assertTrue(r == -1);
	}
	public void testMoverBlancasSinDeber(){
		t = new Tablero(1, "a", "b");
		t.setTurno('n');
		int r = t.mover('b', 2, 2, 3, 2, "", "");
		assertTrue(r == -1);
	}
	
	public void testMoverNoesTufichaB(){
		t = new Tablero(1, "a", "b");
		int r = t.mover('b', 7, 2, 6, 2, "", "");
		assertTrue(r == -3);
	}
	public void testMoverNoEsTufichaN(){
		t = new Tablero(1, "a", "b");
		t.setTurno('n');
		int r = t.mover('n', 2, 2, 3, 2, "", "");
		assertTrue(r == -3);
	}
}
