package ajedrez.server.persistencia;


import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;


/* Gestiona la conexin y el enlace con el servidor de bases de datos. */
class Agente {
	protected static Agente mInstancia = null;
	protected static Connection mBD;
	protected static String mURL;
	// Datos de conexin por defecto
	protected static String sIP = "161.67.27.64";
	protected static String sPuerto = "1433";
	protected static String sNombreBD = "ajedrez6";
	protected static String sUsuario = "sa";
	protected static String sContrasea = "pedro";


	protected Agente() throws SQLException {
		try {
			Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
		}
		catch(ClassNotFoundException eCNF) {
			eCNF.printStackTrace();
			System.exit(0);
		}
		mURL = "jdbc:sqlserver://" + sIP + ":" + sPuerto + ";DatabaseName=" + sNombreBD;
		mBD = DriverManager.getConnection(mURL, sUsuario, sContrasea);
	} /* Fin constructor */


	/**
	 * Devuelve la informacin de contacto de la base de datos.
	 * @return   Devuelve una matriz de cinco componentes:
	 *           [0]=IP, [1]=puerto, [2]=nombreBD, [3]=usuario, [4]=contrasea.
	 */
	public static String[] getInfo() {
		String [] asDev = new String[5];
		asDev[0] = sIP;
		asDev[1] = sPuerto;
		asDev[2] = sNombreBD;
		asDev[3] = sUsuario;
		asDev[4] = sContrasea;
		return asDev;
	} /* Fin mtodo getInfo */


	/**
	 * Fija una nueva informacin de contacto con la base de datos.
	 */
	public static void setInfo(String IP, String Puerto, String NombreBD, String Usuario, String Contrasea) {
		if (mInstancia == null) {
			sIP = IP;
			sPuerto = Puerto;
			sNombreBD = NombreBD;
			sUsuario = Usuario;
			sContrasea = Contrasea;
		}
	} /* Fin mtodo setInfo */


	/**
	 * Devuelve el agente de base de datos.
	 */
	public static Agente getAgente() throws SQLException {
		if (mInstancia == null) {
			mInstancia = new Agente();
		}
		if(Agente.mBD.isClosed()){
			Agente.mBD = DriverManager.getConnection(Agente.mURL, sUsuario, sContrasea);
		}
		return mInstancia;
	} /* Fin mtodo getAgente */


	/**
	 * Devuelve la conexin a la base de datos.
	 */
	public Connection getBD() throws SQLException {
		if (mBD.isClosed()) {
			mBD = DriverManager.getConnection(mURL, sUsuario, sContrasea);
		}
		return mBD;
	} /* Fin mtodo getBD */

} /* Fin clase Agente */
