package ajedrez.server.presen;


import java.awt.Rectangle;
import java.net.MalformedURLException;
import java.rmi.RemoteException;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

import ajedrez.server.comunicaciones.AjedrezServer;
import ajedrez.server.persistencia.Metodos;


/* Clase visual que muestra los parmetros de conexin del servidor. */
public class JFLanzadorServer extends JFrame {
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JLabel jLabelRMI = null;
	private JLabel jLabelRMI_IP = null;
	private JTextField jTextFieldRMI_IP = null;
	private JLabel jLabelRMI_Puerto = null;
	private JTextField jTextFieldRMI_Puerto = null;
	private JLabel jLabelBD = null;
	private JLabel jLabelBD_IP = null;
	private JTextField jTextFieldBD_IP = null;
	private JLabel jLabelBD_Puerto = null;
	private JTextField jTextFieldBD_Puerto = null;
	private JLabel jLabelBD_Nombre = null;
	private JTextField jTextFieldBD_Nombre = null;
	private JLabel jLabelBD_Usuario = null;
	private JTextField jTextFieldBD_Usuario = null;
	private JLabel jLabelBD_Contrasea = null;
	private JPasswordField jPasswordFieldBD_Contrasea = null;
	private JButton jButtonConectar = null;
	private AjedrezServer servidor;
	
	
	/**
	 * This is the default constructor.
	 */
	public JFLanzadorServer() {
		super();
		initialize();
	} /* Fin constructor */
	
	
	/**
	 * This method initializes this.
	 * @return   void
	 */
	private void initialize() {
		this.setSize(551, 361);
		this.setResizable(false);
		this.setContentPane(getJContentPane());
		this.setTitle("Conectar Servidor");
	} /* Fin mtodo initialize */
	
	
	/**
	 * This method initializes jContentPane.
	 * @return   javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabelRMI = new JLabel();
			jLabelRMI.setBounds(new Rectangle(81, 24, 82, 30));
			jLabelRMI.setText("Conexin RMI");
			jLabelRMI_IP = new JLabel();
			jLabelRMI_IP.setBounds(new java.awt.Rectangle(48,111,13,26));
			jLabelRMI_IP.setText("IP");
			jLabelRMI_Puerto = new JLabel();
			jLabelRMI_Puerto.setBounds(new java.awt.Rectangle(46,158,45,26));
			jLabelRMI_Puerto.setText("Puerto");
			jLabelBD = new JLabel();
			jLabelBD.setBounds(new Rectangle(359, 25, 77, 26));
			jLabelBD.setText("Conexin BD");
			jLabelBD_IP = new JLabel();
			jLabelBD_IP.setBounds(new java.awt.Rectangle(317,65,12,30));
			jLabelBD_IP.setText("IP");
			jLabelBD_Puerto = new JLabel();
			jLabelBD_Puerto.setBounds(new java.awt.Rectangle(318,104,40,24));
			jLabelBD_Puerto.setText("Puerto");
			jLabelBD_Nombre = new JLabel();
			jLabelBD_Nombre.setBounds(new java.awt.Rectangle(318,141,54,25));
			jLabelBD_Nombre.setText("Nombre");
			jLabelBD_Usuario = new JLabel();
			jLabelBD_Usuario.setBounds(new java.awt.Rectangle(319,179,53,26));
			jLabelBD_Usuario.setText("Usuario");
			jLabelBD_Contrasea = new JLabel();
			jLabelBD_Contrasea.setBounds(new java.awt.Rectangle(301,217,73,30));
			jLabelBD_Contrasea.setText("Contrasea");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(jLabelRMI, null);
			jContentPane.add(jLabelRMI_IP, null);
			jContentPane.add(getJTextFieldRMI_IP(), null);
			jContentPane.add(jLabelRMI_Puerto, null);
			jContentPane.add(getJTextFieldRMI_Puerto(), null);
			jContentPane.add(jLabelBD, null);
			jContentPane.add(jLabelBD_IP, null);
			jContentPane.add(getJTextFieldBD_IP(), null);
			jContentPane.add(jLabelBD_Puerto, null);
			jContentPane.add(getJTextFieldBD_Puerto(), null);
			jContentPane.add(jLabelBD_Nombre, null);
			jContentPane.add(getJTextFieldBD_Nombre(), null);
			jContentPane.add(jLabelBD_Usuario, null);
			jContentPane.add(getJTextFieldBD_Usuario(), null);
			jContentPane.add(jLabelBD_Contrasea, null);
			jContentPane.add(getJPasswordFieldBD_Contrasea(), null);
			jContentPane.add(getJButtonConectar(), null);
			// Insercin de los datos por defecto de la conexin a la base de datos
			String[] asInfo = Metodos.getInfo();
			jTextFieldBD_IP.setText(asInfo[0]);
			jTextFieldBD_Puerto.setText(asInfo[1]);
			jTextFieldBD_Nombre.setText(asInfo[2]);
			jTextFieldBD_Usuario.setText(asInfo[3]);
			jPasswordFieldBD_Contrasea.setText(asInfo[4]);
		}
		return jContentPane;
	} /* Fin mtodo getJContentPane */
	
	
	/**
	 * This method initializes jTextFieldRMI_IP.
	 * @return   javax.swing.JTextField
	 */
	private JTextField getJTextFieldRMI_IP() {
		if (jTextFieldRMI_IP == null) {
			jTextFieldRMI_IP = new JTextField();
			jTextFieldRMI_IP.setBounds(new java.awt.Rectangle(64,111,153,26));
			jTextFieldRMI_IP.setText("127.0.0.1");
		}
		return jTextFieldRMI_IP;
	} /* Fin mtodo getJTextFieldRMI_IP */
	
	
	/**
	 * This method initializes jTextFieldRMI_Puerto.
	 * @return   javax.swing.JTextField
	 */
	private JTextField getJTextFieldRMI_Puerto() {
		if (jTextFieldRMI_Puerto == null) {
			jTextFieldRMI_Puerto = new JTextField();
			jTextFieldRMI_Puerto.setBounds(new java.awt.Rectangle(99,160,117,24));
			jTextFieldRMI_Puerto.setText("2995");
		}
		return jTextFieldRMI_Puerto;
	} /* Fin mtodo getJTextFieldRMI_Puerto */
	
	
	/**
	 * This method initializes jTextFieldBD_IP.
	 * @return   javax.swing.JTextField
	 */
	private JTextField getJTextFieldBD_IP() {
		if (jTextFieldBD_IP == null) {
			jTextFieldBD_IP = new JTextField();
			jTextFieldBD_IP.setBounds(new java.awt.Rectangle(332,66,153,27));
		}
		return jTextFieldBD_IP;
	} /* Fin mtodo getJTextFieldBD_IP */
	
	
	/**
	 * This method initializes jTextFieldBD_Puerto.
	 * @return   javax.swing.JTextField
	 */
	private JTextField getJTextFieldBD_Puerto() {
		if (jTextFieldBD_Puerto == null) {
			jTextFieldBD_Puerto = new JTextField();
			jTextFieldBD_Puerto.setBounds(new java.awt.Rectangle(365,105,119,23));
		}
		return jTextFieldBD_Puerto;
	} /* Fin mtodo getJTextFieldBD_Puerto */
	
	
	/**
	 * This method initializes jTextFieldBD_Nombre.
	 * @return   javax.swing.JTextField
	 */
	private JTextField getJTextFieldBD_Nombre() {
		if (jTextFieldBD_Nombre == null) {
			jTextFieldBD_Nombre = new JTextField();
			jTextFieldBD_Nombre.setBounds(new java.awt.Rectangle(382,141,102,26));
		}
		return jTextFieldBD_Nombre;
	} /* Fin mtodo getJTextFieldBD_Nombre */
	
	
	/**
	 * This method initializes jTextFieldBD_Usuario.
	 * @return   javax.swing.JTextField
	 */
	private JTextField getJTextFieldBD_Usuario() {
		if (jTextFieldBD_Usuario == null) {
			jTextFieldBD_Usuario = new JTextField();
			jTextFieldBD_Usuario.setBounds(new java.awt.Rectangle(383,180,102,24));
		}
		return jTextFieldBD_Usuario;
	} /* Fin mtodo getJTextFieldBD_Usuario */
	
	
	/**
	 * This method initializes jPasswordFieldBD_Contrasea.
	 * @return   javax.swing.JPasswordField
	 */
	private JPasswordField getJPasswordFieldBD_Contrasea() {
		if (jPasswordFieldBD_Contrasea == null) {
			jPasswordFieldBD_Contrasea = new JPasswordField();
			jPasswordFieldBD_Contrasea.setBounds(new java.awt.Rectangle(386,218,97,26));
		}
		return jPasswordFieldBD_Contrasea;
	} /* Fin mtodo getJPasswordFieldBD_Contrasea */
	
	
	/**
	 * This method initializes jButtonConectar.
	 * @return   javax.swing.JButton
	 */
	private JButton getJButtonConectar() {
		if (jButtonConectar == null) {
			jButtonConectar = new JButton();
			jButtonConectar.setBounds(new java.awt.Rectangle(193,274,148,43));
			jButtonConectar.setText("Conectar");
			final JFrame ventanaActual = this;
			jButtonConectar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {		
					// Conexin a la BD
					try {
						int nPuerto = Integer.parseInt(jTextFieldBD_Puerto.getText());
						String sPasswd = "";
						for (int i=0; i<jPasswordFieldBD_Contrasea.getPassword().length; i++) {
							sPasswd += jPasswordFieldBD_Contrasea.getPassword()[i];
						}
						Metodos.setInfo(jTextFieldBD_IP.getText(), jTextFieldBD_Puerto.getText(), jTextFieldBD_Nombre.getText(), jTextFieldBD_Usuario.getText(), sPasswd);
						Metodos.comprobarConexion();
						// Creacin del servidor
						try {
							servidor = new AjedrezServer();
							// Conexin a RMI
							try {
								nPuerto = Integer.parseInt(jTextFieldRMI_Puerto.getText());
								servidor.conectar(jTextFieldRMI_IP.getText(), nPuerto);
								FVentanaServidor ventanaServidor = new FVentanaServidor(servidor);
								ventanaServidor.setVisible(true);
								ventanaActual.dispose();
							}
							catch (MalformedURLException eMURL) {
								//eMURL.printStackTrace();
								mostrarMensaje(-1);
							}
							catch (NumberFormatException eNF) {
								//eNF.printStackTrace();
								mostrarMensaje(-2);
							}
							catch (RemoteException eR) {
								//eR.printStackTrace();
								mostrarMensaje(-1);
							}
						}
						catch (RemoteException eR) {
							//eR.printStackTrace();
							mostrarMensaje(-1);
						}
					}
					catch (NumberFormatException eNF) {
						//eNF.printStackTrace();
						mostrarMensaje(-4);
					}
					catch (Exception exc) {
						//exc.printStackTrace();
						mostrarMensaje(-3);
					}
				}
			});
		}
		return jButtonConectar;
	} /* Fin mtodo getJButtonConectar */
	
	
	/**
	 * Muestra un mensaje informando sobre la conexin.
	 */
	protected void mostrarMensaje(int nCaso) {
		switch (nCaso) {
			case -1:
				JOptionPane.showMessageDialog(this,"Hubo un error en la conexin con el servicio de RMI.","Error en la conexin con el servicio de RMI",JOptionPane.ERROR_MESSAGE);
				break;
			case -2:
				JOptionPane.showMessageDialog(this,"El puerto del servicio de RMI debe ser un valor numrico.","Error en la conexin con el servicio de RMI",JOptionPane.ERROR_MESSAGE);
				break;
			case -3:
				JOptionPane.showMessageDialog(this,"Hubo un error en la conexin con la base de datos.","Error en la conexin con la base de datos",JOptionPane.ERROR_MESSAGE);
				break;
			case -4:
				JOptionPane.showMessageDialog(this,"El puerto de conexin con la base de datos debe ser un valor numrico.","Error en la conexin con la base de datos",JOptionPane.ERROR_MESSAGE);
				break;
		}
	} /* Fin mtodo mostrarMensaje */
	
//@jve:decl-index=0:visual-constraint="10,10"
} /* Fin clase visual JFLanzadorServer  */
